<?php

include_once(dirname(__FILE__).'/../Database.php');
include_once(dirname(__FILE__).'/Types/Type.php');

class Form
{
  var $FormManager;
  var $Definition;
  var $Values;
  var $ValuesFilter;
  var $OnSubmit;
  var $Database;
  
  function __construct($FormManager)
  {      
    $this->FormManager = &$FormManager;
    $this->Database = $FormManager->Database;
    $this->Definition = array();
    $this->Values = array();    
    $this->ValuesFilter = array();    
    $this->OnSubmit = '';
  }
  
  function SetClass($Name)
  {
    $this->Definition = &$this->FormManager->Classes[$Name];    
  } 

  function ShowViewForm()
  {
    $Table = array(
      //'Header' => array('Položka', 'Hodnota'),
      'Rows' => array(),
    );
    foreach($this->Definition['Items'] as $Index => $Item)
    if(!array_key_exists($Item['Type'], $this->FormManager->FormTypes) or 
    (array_key_exists($Item['Type'], $this->FormManager->FormTypes) and 
    ($this->FormManager->FormTypes[$Item['Type']]['Type'] != 'ManyToOne')))
    {
      if(!array_key_exists($Index, $this->Values) and isset($Item['Default'])) $this->Values[$Index] = $Item['Default']; 
        if(array_key_exists($Item['Type'], $this->FormManager->FormTypes))
        {            
          if(!array_key_exists($Item['Type'], $this->FormManager->Type->TypeDefinitionList)) 
            $this->FormManager->Type->RegisterType($Item['Type'], '', $this->FormManager->FormTypes[$Item['Type']]);
          if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Reference') 
            $UseType = 'OneToMany';
          else if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Enumeration') 
            $UseType = 'Enumeration';
        } else $UseType = $Item['Type'];            
      $Edit = $this->FormManager->Type->ExecuteTypeEvent($UseType, 'OnView', 
        array('Value' => $this->Values[$Index], 'Name' => $Index, 
        'Type' => $Item['Type'], 'Values' => $this->Values,             
        'Filter' => $this->ValuesFilter[$Index]));
      if(array_key_exists('Suffix', $Item)) $Edit .= ' '.$Item['Suffix'];
      if(!$this->FormManager->Type->IsHidden($UseType))
        array_push($Table['Rows'], array($Item['Caption'].':', $Edit));
    }
    $Output = '<fieldset><legend>'.$this->Definition['Title'].'</legend>'.Table($Table).
    '</fieldset>';
    return($Output); 
  }

  function ShowEditForm()
  {
    if(!array_key_exists('SubmitText', $this->Definition)) $this->Definition['SubmitText'] = 'Uložit';
    $Output = '<form enctype="multipart/form-data" class="Form" action="'.$this->OnSubmit.'" method="post">'.$this->ShowEditBlock().
      '<div><input type="submit" value="'.$this->Definition['SubmitText'].'" /> '.
      '<input type="button" value="Zrušit" onclick="location.href=\'?\'"/></div></form>';
    return($Output);
  }

  function ShowEditBlock($Context = '')
  {
    $Hidden = '';
    $IsHidden = false;
    $Table = array(
      //'Header' => array('Položka', 'Hodnota'),
      'Rows' => array(),
    );
    if($Context != '') $Context = $Context.'-';
    foreach($this->Definition['Items'] as $Index => $Item)
    {
      if(!array_key_exists('ReadOnly', $Item)) $Item['ReadOnly'] = false;
    if($Item['ReadOnly'] == false)
    if(!array_key_exists($Item['Type'], $this->FormManager->FormTypes) or 
    (array_key_exists($Item['Type'], $this->FormManager->FormTypes) and 
    ($this->FormManager->FormTypes[$Item['Type']]['Type'] != 'ManyToOne')))
    {
      if(!array_key_exists($Index, $this->Values) and isset($Item['Default'])) $this->Values[$Index] = $Item['Default']; 
        $Parameters = array('Value' => $this->Values[$Index], 'Name' => $Index, 
            'Type' => $Item['Type'], 'Values' => $this->Values);
        if(array_key_exists('Null', $Item)) $Parameters['Null'] = $Item['Null'];
          else unset($Parameters['Null']);

        if(array_key_exists($Item['Type'], $this->FormManager->FormTypes))
        {            
          if(!array_key_exists($Item['Type'], $this->FormManager->Type->TypeDefinitionList)) 
            $this->FormManager->Type->RegisterType($Item['Type'], '', 
              $this->FormManager->FormTypes[$Item['Type']]);
          if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Reference') 
          {
            $UseType = 'OneToMany';
          } else if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Enumeration') 
            $UseType = 'Enumeration';
        } else $UseType = $Item['Type'];
        $Edit = $this->FormManager->Type->ExecuteTypeEvent($UseType, 'OnEdit', $Parameters);
        if(array_key_exists('Suffix', $Item)) $Edit .= $Item['Suffix'];

      if(!$this->FormManager->Type->IsHidden($UseType))
          array_push($Table['Rows'], array($Item['Caption'].':', $Edit));
      else $Hidden .= $Edit;
    }
    }
    $Output = '<fieldset><legend>'.$this->Definition['Title'].'</legend>'.Table($Table).
    $Hidden.'</fieldset>';
    return($Output); 
  }

  function LoadValuesFromDatabase($Id)
  {    
    foreach($this->Definition['Items'] as $Index => $Item)
    if(!array_key_exists($Item['Type'], $this->FormManager->FormTypes) or 
    (array_key_exists($Item['Type'], $this->FormManager->FormTypes) and 
    ($this->FormManager->FormTypes[$Item['Type']]['Type'] != 'ManyToOne')))
    {
      if(!array_key_exists($Index, $this->Values) and isset($Item['Default'])) $this->Values[$Index] = $Item['Default']; 
        if(array_key_exists($Item['Type'], $this->FormManager->FormTypes))
        {            
          if(!array_key_exists($Item['Type'], $this->FormManager->Type->TypeDefinitionList)) 
            $this->FormManager->Type->RegisterType($Item['Type'], '', 
              $this->FormManager->FormTypes[$Item['Type']]);
          if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Reference') 
            $UseType = 'OneToMany';
          else if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Enumeration') 
            $UseType = 'Enumeration';
        } else $UseType = $Item['Type'];
      $Columns[] = $this->FormManager->Type->ExecuteTypeEvent($UseType, 'OnFilterNameQuery',
        array('Name' => $Index, 'Type' => $Item['Type']));
    }
    $Columns = implode(',', $Columns);
    $DbResult = $this->Database->query('SELECT '.$Columns.' FROM `'.$this->Definition['Table'].'` AS `T` WHERE `T`.`Id`='.$Id);
    $DbRow = $DbResult->fetch_array();
    foreach($this->Definition['Items'] as $Index => $Item)
    if(!array_key_exists($Item['Type'], $this->FormManager->FormTypes) or 
    (array_key_exists($Item['Type'], $this->FormManager->FormTypes) and 
    ($this->FormManager->FormTypes[$Item['Type']]['Type'] != 'ManyToOne')))
    {
      if(!array_key_exists($Index, $this->Values) and isset($Item['Default'])) $this->Values[$Index] = $Item['Default']; 
        if(array_key_exists($Item['Type'], $this->FormManager->FormTypes))
        {            
          if(!array_key_exists($Item['Type'], $this->FormManager->Type->TypeDefinitionList)) 
            $this->FormManager->Type->RegisterType($Item['Type'], '', 
              $this->FormManager->FormTypes[$Item['Type']]);
          if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Reference') 
            $UseType = 'OneToMany';
          else if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Enumeration') 
            $UseType = 'Enumeration';
        } else $UseType = $Item['Type'];
        $this->Values[$Index] = $this->FormManager->Type->ExecuteTypeEvent($UseType, 'OnLoadDb', 
            array('Value' => $DbRow[$Index], 'Name' => $Index, 
            'Type' => $Item['Type'], 'Values' => $this->Values));
        $this->ValuesFilter[$Index] = $DbRow[$Index.'_Filter'];
    }
  }

  function SaveValuesToDatabase($Id)
  {
    $Values = array();
    foreach($this->Definition['Items'] as $Index => $Item)
    {
      if(!array_key_exists('ReadOnly', $Item)) $Item['ReadOnly'] = false;
      if($Item['ReadOnly'] == false)
    if(!array_key_exists($Item['Type'], $this->FormManager->FormTypes) or 
    (array_key_exists($Item['Type'], $this->FormManager->FormTypes) and 
    ($this->FormManager->FormTypes[$Item['Type']]['Type'] != 'ManyToOne')))
    {
      if(!array_key_exists($Index, $this->Values) and isset($Item['Default'])) $this->Values[$Index] = $Item['Default']; 
      $Parameters = array('Value' => $this->Values[$Index], 'Name' => $Index, 
          'Type' => $Item['Type'], 'Values' => $this->Values);
      
        if(array_key_exists($Item['Type'], $this->FormManager->FormTypes))
        {            
          if(!array_key_exists($Item['Type'], $this->FormManager->Type->TypeDefinitionList)) 
            $this->FormManager->Type->RegisterType($Item['Type'], '', 
              $this->FormManager->FormTypes[$Item['Type']]);
          if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Reference') 
          {
            $UseType = 'OneToMany';
          }
          else if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Enumeration') 
            $UseType = 'Enumeration';
        } else $UseType = $Item['Type'];
        $Values[$Index] = $this->FormManager->Type->ExecuteTypeEvent($UseType, 'OnSaveDb', $Parameters);
        if(($Item['Type'] == 'Password') and ($Values[$Index] == '')) unset($Values[$Index]);
    }
    }
    if($Id == 0)
    {
      $Values['Id'] = $Id;
      $DbResult = $this->Database->insert($this->Definition['Table'], $Values);
    } else
      $DbResult = $this->Database->update($this->Definition['Table'], 'Id='.$Id, $Values);
  }

  function LoadValuesFromForm()
  {
    $this->Values = $this->LoadValuesFromFormBlock();
  }

  function LoadValuesFromFormBlock($Context = '')
  {
    if($Context != '') $Context = $Context.'-';
    $Values = array();
    foreach($this->Definition['Items'] as $Index => $Item)
    if((!array_key_exists($Item['Type'], $this->FormManager->FormTypes) or 
    (array_key_exists($Item['Type'], $this->FormManager->FormTypes) and
    ($this->FormManager->FormTypes[$Item['Type']]['Type'] != 'ManyToOne'))) and
    (!array_key_exists('ReadOnly', $Item) or 
    (array_key_exists('ReadOnly', $Item) and
    ($Item['ReadOnly'] != true))))
    {
      //if(array_key_exists($Context.$Index, $_POST))
        if(array_key_exists($Item['Type'], $this->FormManager->FormTypes))
        {            
          if(!array_key_exists($Item['Type'], $this->FormManager->Type->TypeDefinitionList)) 
            $this->FormManager->Type->RegisterType($Item['Type'], '', 
              $this->FormManager->FormTypes[$Item['Type']]);
          if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Reference') 
            $UseType = 'OneToMany';
          else if($this->FormManager->FormTypes[$Item['Type']]['Type'] == 'Enumeration') 
            $UseType = 'Enumeration';
        } else $UseType = $Item['Type'];
        $Values[$Index] = $this->FormManager->Type->ExecuteTypeEvent($UseType, 'OnLoad', 
          array('Name' => $Index, 'Type' => $Item['Type'], 'Values' => $this->Values));
    }
    return($Values);
  }
}

function MakeLink($Target, $Title)
{
  return('<a href="'.$Target.'">'.$Title.'</a>'); 
}

function Table($Table)
{
  $Result = '<table class="BasicTable">';
  if(array_key_exists('Header', $Table))
  {
    $Result .= '<tr>';
    foreach($Table['Header'] as $Item)
      $Result .= '<th>'.$Item.'</th>';
    $Result .= '</tr>';
  }
  foreach($Table['Rows'] as $Row)
  {
    $Result .= '<tr>';
    foreach($Row as $Index => $Item)
    {
      if($Index == 0) $Class = ' class="Header"'; else $Class = '';
      $Result .= '<td'.$Class.' style="width: '.(floor(100 / count($Row))).'%">'.$Item.'</td>';
    }
    $Result .= '</tr>';
  }
  $Result .= '</table>';
  return($Result);
}

class FormManager
{
  var $Classes;
  var $FormTypes;
  var $Database;
  var $Type;
  var $RootURL;
  var $ShowRelation;
  
  function __construct($Database)
  {
    $this->Database = &$Database;
    $this->Classes = array();
    $this->FormTypes = array();
    $this->Type = new Type($this);
    $this->ShowRelation = false;   
  }
  
  function RegisterClass($Name, $Class)
  {
    $this->Classes[$Name] = $Class;
  }
  
  function UnregisterClass($Name)
  {
    unset($this->Classes[$Name]);
  }

  function RegisterFormType($Name, $Class)
  {
    $this->FormTypes[$Name] = $Class;
  }
  
  function UnregisterFormType($Name)
  {
    unset($this->FormTypes[$Name]);
  }
}

?>
